﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Vehicles
{
    class Program
    {

        static void TestEquals()
        {

            // IEquitable:Equals()
            double value1 = 12;
            int value2 = 12;

            object object1 = value1;
            object object2 = value2;

            Console.WriteLine("{0} ({1}) = {2} ({3}): {4}",
                              object1, object1.GetType().Name,
                              object2, object2.GetType().Name,
                              object1.Equals(object2));

            Console.WriteLine("{0} ({1}) = {2} ({3}): {4}",
                              value1, value1.GetType().Name,
                              value2, value2.GetType().Name,
                              value2.Equals(value1));

            Console.WriteLine("{0} ({1}) = {2} ({3}): {4}",
                  value1, value1.GetType().Name,
                  value2, value2.GetType().Name,
                  value1.Equals(value2));

            // Testing Equals on Values
            int i = 7, j = 7;
            double d = 7.0;

            Console.WriteLine("Testing Values");
            Console.WriteLine(i.Equals(d));
            Console.WriteLine(d.Equals(i));
            Console.WriteLine(i.Equals(j));
            Console.WriteLine(j.Equals(i));
            Console.WriteLine();

            // Testing Equals on References
            Console.WriteLine("Testing references");

            // car c and c2 have the same properties but Equals will be false
            Car c  = new Car(4, 1000, 5, 16, 40, Vehicle.FUEL_TYPE.PETROL, 35, 175, "VW", "Golf", 2016, 135000, "xyz-890");
            Car c1 = new Car(4, 1000, 5, 16, 40, Vehicle.FUEL_TYPE.PETROL, 35, 175, "VW", "Golf", 2016, 135000, "abc-123");
            Car c2 = new Car(4, 1000, 5, 16, 40, Vehicle.FUEL_TYPE.PETROL, 35, 175, "VW", "Golf", 2016, 135000, "xyz-890");

            Console.WriteLine(c.Equals(c1));
            Console.WriteLine(c.Equals(c2));

            Console.WriteLine(c1.Equals(c));
            Console.WriteLine(c1.Equals(c2));

            Console.WriteLine(c2.Equals(c));
            Console.WriteLine(c2.Equals(c1));

            c2 = c1;
            Console.WriteLine(c2.Equals(c1));
            Console.WriteLine(c1.Equals(c2));
            Console.WriteLine();
        }

        static void TestPolymorphism()
        {
            Car c = new Car(4, 1000, 5, 16, 40, Vehicle.FUEL_TYPE.PETROL, 35, 175, "VW", "Golf", 2016, 135000, "xyz-890");
            c.GetNumWheel();
            Console.WriteLine(c.GetEngineCC());
            c.SetEngineCC(1000);
            Console.WriteLine(c.GetEngineCC());

            Vehicle v = (Vehicle)c;

            Console.WriteLine(v.GetEngineCC());
            c.SetEngineCC(2000);
            Console.WriteLine(v.GetEngineCC());

            v.SetEngineCC(3000);
            Console.WriteLine(c.GetEngineCC());

            Console.WriteLine("CAR");
            Console.WriteLine(c);
            Console.WriteLine(c.VirtualFunc());
            Console.WriteLine(c.VirtualFunc_New());
            Console.WriteLine(c.NonVirtualFunc());
            Console.WriteLine(c.VirtualFunc_Nothing());


            Console.WriteLine();
            c.Move(200);

            Console.WriteLine("VEHICLE");
            Console.WriteLine(v);
            Console.WriteLine(v.VirtualFunc());
            Console.WriteLine(v.VirtualFunc_New());
            Console.WriteLine(v.NonVirtualFunc());
            Console.WriteLine(v.VirtualFunc_Nothing());

            Console.WriteLine("(Car) VEHICLE");
            Console.WriteLine(v);
            Console.WriteLine(((Car)v).VirtualFunc());
            Console.WriteLine(((Car)v).VirtualFunc_New());
            Console.WriteLine(((Car)v).NonVirtualFunc());
            Console.WriteLine(((Car)v).VirtualFunc_Nothing());

        }

        static void TestComparer()
        {
            Car[] cars = { new Car(4, 1000, 5, 16, 40, Vehicle.FUEL_TYPE.PETROL, 35, 175, "VW", "Golf GTI", 2016, 135000, "xyz-890"),
                            new Car(4, 1000, 5, 16, 40, Vehicle.FUEL_TYPE.PETROL, 35, 165, "VW", "Jetta ", 2016, 135000, "abc-123"),
                            new Car(4, 1000, 5, 16, 40, Vehicle.FUEL_TYPE.PETROL, 35, 220, "VW", "Golf RS", 2016, 135000, "xyz-890"),
                            new Car(4, 1000, 5, 16, 40, Vehicle.FUEL_TYPE.PETROL, 35, 120, "VW", "Polo", 2016, 135000, "xyz-890") };

            CompareBySpeed cbs = new CompareBySpeed();
            Array.Sort(cars, cbs);
        }


        static void Main(string[] args)
        {
            TestEquals();

            TestPolymorphism();

            TestComparer();

            Console.ReadKey();
        }
    }
}
